package Collector;
use Device::SerialPort;
use Exporter ();
use strict;
our $VERSION = '1.4 kedr';
our @EXPORT = qw( open_port close_port conf login download indoad redoad start errlog infolog checkstop stopload addcrontask delcrontask );
our @EXPORT_OK = qw($app, $DIR);
our @ISA = qw(Exporter);
{
    my ( $station, $module, $module_min, $module_max, $device, $speed, $databits, $parity, $stopbits, $handshake, @schedule );
    my ( $logdir, $perm, $rotate, $compression, $compressionlevel );
    my ( $fname, $fperm, $frotate, $fcompression, $fcompressionlevel, $ftext, $faregexp, $fbregexp );
    my ( $bip, $bport, $bspool, $bbad );
    my $app="PLAN";
    my $logfile = "colit.log";
    my $cronfile = "crontab";
    $databits ="8";
    $parity ="none";
    $stopbits = "1";
    our $DIR = "/usr/local/bin/colit";
    my $LOGCFGFILE = "m200log.cfg";
    my $CFGFILE = "m200.cfg";
    my $ALARMDIR = "/root";
    my $logdir = $DIR;
    my $kfilepath = "/tmp/";
    my $kfilename;
    my $to_login = 1500; #timeout to login
    my $to_atscommand = 5000; #ats command timeout
    my $to_shellcommand = 100; #shell command timeout

    my $TTCcount = 60;

    my $password = "POISON;"; # Пароль к станции ItelTel
    my $handmode_run = "Automatic mode crashed, handmode run\n";

    # Значения по умолчанию для выгрузки, morning - начало дня, dbuf - значение буфера при котором начинается выгрузка днем,
    # evening - начало ночи,  nbuf - значение буфера при котором начинается выгрузка ночью.
    my ($morning,$dbuf,$evening,$nbuf) = (28800,25,61200,50);

    my $indoad_count = 1;
    # Порт
    my $port;

    my $response;
    # Если в течении $admintime минут нет ответа от станции, сообщаем админитратору
    my $admintime = 30;
############  Доступна из командной строки   ############
# проверить и считать конфигурационные файлы		#
#########################################################
sub conf
{
#-------------------parse log config file---------------------
    if( not parse_logcfg("$DIR/$LOGCFGFILE") )
    {
	print "Script stopped\n";
	return 0;
    }
#-------------------parse config file-------------------------
    if( not parse_cfg("$DIR/$CFGFILE") )
    {
	print "Script stopped\n";
	errlog( "Script stopped" );
	return 0;
    }
    return 1;
#-------------------------------------------------------------	
}

############  Доступна из командной строки   ############
# просто залогиниться на конктретный модуль             #
# как применять пока не знаю				#
#########################################################
sub login
{
  my $cmodule = shift;
  # Если не задан модуль, то берем из конфига
  $cmodule = $module if(!defined($cmodule));

  # Считываем конфиг
  exit 0 if( not conf() );
  # ER в случае ошибки выходим из программы

  # Открываем порт
  exit 0 if( not open_port() );
  # ER в случае ошибки выходим из программы
  $_ = login_after_open($cmodule);
  if($_)
  {
    infolog("Подключение прошло успешно");
	print "Подключение прошло успешно\n";
  }
  else
  {
    errlog("Подключиться не удалось");
	print "Подключиться не удалось\n";
  }
  close_port();
}

############  Доступна из командной строки   #################
# логинимся на конкретный модуль и скачиваем файл по кермиту.#
##############################################################
sub download
{
    $kfilename = shift;
    my $filepath = shift;
    my $download_directory = shift;
    $bspool = $download_directory if(defined($download_directory));
    $kfilepath = $filepath if(defined($filepath));
    
    # Считываем конфиг
    exit 0 if( not conf() );
    # ER в случае ошибки выходим из программы
    return download_internal($module);
}

sub download_internal
{
    my $cmodule = shift;
    infolog("---------------------------------------------------------");
    infolog("                 download_internal BEGIN");
    infolog("---------------------------------------------------------");
    
    my $i = 0;
    for( $i = 0; $i<3 ; $i++)
    {
	  # usage filename [port] [speed] [module] [download-directory] [filepath] [filename]
	  $_ = `$DIR/commandfile $device $speed $cmodule $bspool $kfilepath $kfilename`;
	  if(/COMPLETE/)
	  {
		infolog($_);
		infolog("Файл '$kfilename' успешно записан в директорию: $bspool.");
		#check download filename
		infolog("Проверим название файла");
		my $filetime = substr($kfilename, 0, 15);
		my $oldfilename = `ls $bspool | grep $filetime`;
		infolog("Выполнилась команда: ls $bspool | grep $filetime");
		chomp($oldfilename);
		if( $oldfilename ne $kfilename )
		{
		  $response = `mv $bspool/$oldfilename $bspool/$kfilename`;
		  infolog("Выполнилась команда: mv $bspool/$oldfilename $bspool/$kfilename");
		}
		if( $fperm )
		{
	  	  $response = `chmod $fperm $bspool/$kfilename`;
	  	  infolog("Выполнилась команда: chmod $fperm $bspool/$kfilename");
		}
		infolog("---------------------------------------------------------");
		infolog("                 download_internal END");
		infolog("---------------------------------------------------------");
		return 1;
	  }
	  errlog($_);
    }
    errlog("Не удалось скачать файл");
    infolog("---------------------------------------------------------");
    infolog("                 download_internal END");
    infolog("---------------------------------------------------------");
    return 0;
}



############  Доступна из командной строки   ############
# Проверка: можно ли выгружать?				#
#########################################################
sub indoad
{
  my $cmodule = shift;
  # Если не задан модуль, то берем из конфига
  $cmodule = $module if(!defined($cmodule));
  # Считываем конфиг
  exit 0 if( not conf() );
  # ER в случае ошибки выходим из программы
  stopload( 0 );
    
  # Открываем порт
  exit 0 if( not open_port() );
  # ER в случае ошибки выходим из программы

  # Выход из цикла только в случае четкого ответа: выгружать или нет.
  login_after_open($cmodule);

  if( indoad_check($cmodule) == 1 )
  {
    # пора выгружать
    print "пора выгружать\n";
  }
  else
  {
    # выгружать рано
    print "выгружать рано\n";
  }
  close_port();

}

############  Доступна из командной строки   #######################
# Полная выгрузка, включая сохранение файла в локальной директории.#
####################################################################
sub redoad
{
  my $cmodule = shift;
  # Если не задан модуль, то берем из конфига
  $cmodule = $module if(!defined($cmodule));

  # Считываем конфиг
  exit 0 if( not conf() );
  # ER в случае ошибки выходим из программы
  stopload( 0 );
    
  # Открываем порт
  exit 0 if( not open_port() );
  # ER в случае ошибки выходим из программы
  # Логинемся на модуль
  login_after_open( $cmodule );

  # Дальше идет выгрузка
  # Заморозка буфера
  infolog( "*** Начинаем выгрузку на модуле $cmodule" );
  svdoad( $cmodule );
  infolog( "*** Скачиваем файл" );
  download_internal( $cmodule );
  infolog( "*** Выгрузка на модуле $cmodule завершена" );
  close_port();
}

############  Доступна из командной строки   #############
# Запустить плановый режим, с добавлением заданий в крон.#
##########################################################
sub start
{
  # Считываем конфиг
  exit 0 if( not conf() );
  # ER в случае ошибки выходим из программы
  stopload(0);
  #
  addcrontask();
  # Открываем порт
  exit 0 if( not open_port() );
  # ER в случае ошибки выходим из программы

  # Цикл по всем модулям                       
  # Логинемся на модуль
  # Если пора выгружать, то выгружаем,
  # Иначе переходим на другой модуль
  my $taskmodulecount = 0;
  my $cmodule = $module_min;
  while()
  {
	# Логинемся на модуль
	login_after_open($cmodule);

	# Проверяем пора ли выполнять задание по расписанию
	checktask();
	
	if($app eq "PLAN")
	{
	  # Выгружаем только в случае заполненности буфера
	  if( not indoad_check($cmodule) )
	  {
	  	if( $cmodule == $module_max )
		{
		  infolog("Следующий цикл выгрузки начнется через минуту.");
		  sleep 20;
		  checkstop();
		  sleep 20;
		  checkstop();
		  sleep 20;
		  $cmodule = $module_min;
		}
		else
		{
		  $cmodule++;
		}
		checkstop();
		next;
	  }
	}
	#Дальше идет выгрузка
	#Заморозка буфера
	infolog("*** Начинаем выгрузку на модуле $cmodule");
	svdoad($cmodule);
	infolog("*** Скачиваем файл");
	download_internal($cmodule);
	infolog("*** Выгрузка на модуле $cmodule завершена");
	
	if($app eq "TASK")
	{
	  if($taskmodulecount == $module_max-$module_min)
	  {
		$app = "PLAN";
		stopload(0);
		$taskmodulecount = 0;
	  }
	  else
	  {
		$taskmodulecount++;
	  }
	}

	if( ($cmodule == $module_max) && ($app eq "PLAN") )
	{
	  infolog("Следующий цикл выгрузки начнется через минуту.");
	  sleep 20;
	  checkstop();
	  sleep 20;
	  checkstop();
	  sleep 20;
	}
	
	if($cmodule == $module_max)
	{
	  $cmodule = $module_min;
	}
	else
	{
	  $cmodule++;
	}
	checkstop();
  }
  close_port();
}


############  Доступна из командной строки   ############
# ручной режим						#
#########################################################
sub handmode
{
    # Считываем конфиг
    exit 0 if( not conf() );
    # ER в случае ошибки выходим из программы
    stopload(0);

    open_port();
    handmode_after_open();
}

#--------------------------------------------------------------------

# Открываем порт
#
#
sub open_port
{
    infolog("Начинаем взаимодействие с АТС");
    $port = new Device::SerialPort($device);
    if($port)
    {
	infolog("Порт '$device' открыт");
    }
    else
    {
	errlog("Не удалось открыть порт $device: $!");
	return 0;
    }

    # Baud rate
    $speed=$port->baudrate($speed);
    infolog("  Got baud: $speed");

    # Databits
    $databits=$port->databits($databits);
    infolog("  Got databits: $databits");

    # Parity
    $parity=$port->parity($parity);
    infolog("  Got parity: $parity");

    # Stopbits
    $stopbits=$port->stopbits($stopbits);
    infolog("  Got stopbits: $stopbits");

    $port->lookclear();
    $port->read_const_time(100);
    $port->read_char_time(5);
    $port->save("$DIR/port.conf");
    return 1;
}



# Закрываем порт
#
#
sub close_port
{
  if(!defined($port))
  {
	errlog("\$port is undef. порт не определен.");
	return 0;
  }
  if(!$port->close)
  {
	errlog("Port $port failed to close. Не удалось закрыть порт.");
	return 0;
  }
  undef $port;
  infolog("Port closed. Порт закрыт.");
  return 1;
}

# Логинемся на конкретный модуль
# $module_current - номер конкретного модуля
# Работает только после того как порт будет открыт
sub login_after_open
{
  # LOGIN
  my $cmodule = shift;
  infolog("---------------------------------------------------------");
  infolog("                 login_after_open BEGIN");
  infolog("---------------------------------------------------------");
  infolog( "Подключаемся к модулю $cmodule" );

  my $iteration = 0;
  # Бесконечный цикл, пока вручную не остановят скрипт.
  while()
  {
	if( $iteration++ > 0 )
	{
      infolog( "Повторим попытку соединения через 1 мин." );
      sleep 60;
	}
	
	sendsms( "Нет соединения с $station" ) if( $iteration > 30 );
	
	infolog( "Подключаемся к модулю $cmodule. Попытка $iteration." );
	
	# Если было изначально приглашение для выбора модуля, то сбросим это приглашение.
	writechunk(";");
        $_ = readport($to_login, 2, "", 1);
	# Требуем приглашения от станции.
	writechunk("\$");
	$_ = readport($to_login, 5, "Passwd<", 1);
	# Если станция пароль не запрашивает.
	if(!/Passwd</)
	{
	  #LOGOUT
	  # То вероятно, мы уже залогинились, либо на модуле станции 'C[0-9]<',либо в шелле '#'.
	  writechunk(";\n");
	  $_ = readport($to_login, 5, "C[0-9]<|#", 1);
	  # Если в шелле.
	  if(!/C\d</)
	  {
		if(!/#/)
		{
	      errlog("Неожиданный ответ, ожидалось '#'. Начинаем сначала.");
		  next;
		}
		# Вводим символ конца файла, для выхода из шелла.
		writechunk(chr(04));
		$_ = readport($to_login,5,"C[0-9]<",1);
		if(!/C\d</)
		{
		  errlog("Неожиданный ответ, ожидалось 'C\\d<'");
		  next;
		}
	  }
	  # Если в модуле нужной нам станции, то ура, задача выполнена.
	  if(/C$cmodule</)
	  {
	    infolog("---------------------------------------------------------");
	    infolog("                 login_after_open END");
	    infolog("---------------------------------------------------------");
		return 1;
	  }
	    
	  # Иначе завершаем сеанс со станцией.
	  writechunk("end;");
	  $_ = readport($to_login,5,"",1);
	  if(!/end;/)
	  {
		errlog("Неожиданный ответ, ожидалось 'end;'");
		next;
	  }
	  sleep 1;
	  #.. и вновь требуем приглашения от станции.
	  writechunk("\$");
	  $_ = readport($to_login, 5, "Passwd<", 1);
	}
	# Теперь мы точно разлогинены со станцией, и ожидаем приглашения на ввод пароля.
	if(!/Passwd</)
	{
	  errlog("Неожиданный ответ, ожидалось 'Passwd<'");
	  next;
	}
	# PASSWORD
	# Вводим пароль.
	writechunk($password);
	$_ = readport($to_login,5,"N.exchange<",1);
	# Ожидаем приглашение на выбор модуля.
	if(!/N.exchange</)
	{
	  errlog("Неожиданный ответ, ожидалось 'N.exchange<'");
	  next;
	}
	# MODULE
	# Вводим номер модуля.
	writechunk("$cmodule;");
	$_ = readport($to_login,5,"C$cmodule<",1);
	# Если соединились с модулем,
	if(!/C$cmodule</ )
	{
	  errlog("Неожиданный ответ, ожидалось C$cmodule<");
	  print "Module login failed\n";
	  next;
	}
	# то ура, задача выполнена.
    infolog("---------------------------------------------------------");
    infolog("                 login_after_open END");
    infolog("---------------------------------------------------------");
	return 1;
  }
  infolog("Попытка соединения не удалась.");
}


# Проверка пора ли начинать выгрузку.
# return [-1,0,1] -1 - ошибка, 0 - еще рано, 1 - уже пора.
# $cmodule - текущий модуль.
sub indoad_check
{
  my $cmodule = shift;
  infolog("---------------------------------------------------------");
  infolog("                 indoad_check BEGIN");
  infolog("---------------------------------------------------------");
  infolog("Проверим, пора ли начинать выгрузку для модуля '$cmodule'");

  # Изначально предполагаем что выгружать не нужно
  my $run = 0;
  my $iteration = 0;
  while()
  {
	if( $iteration++ > 0 )
	{
      infolog( "Повторим попытку через 30 сек." );
      sleep 15;
      checkstop();
      sleep 15;
	}
	
	sendsms( "$station: команда indoad не подается более 30 мин" ) if( $iteration > 30 );
	# Даем команду indoad; чтобы узнать загруженность буфера
	writechunk("indoad;");
	$_ = readport($to_atscommand,10,"C$cmodule<",1);
	# Если получили неожиданный ответ, то..
	last if(/indoad:command executed/);
	errlog("Неожиданный ответ, ожидалось 'indoad:command executed'");
  }
  # Разобьем ответ станции по строкам.
  my @indoad = split(/\n/);
  my $maxbuffer = 0;

  # Найдем максимальное значение загруженности буфера.
  foreach(@indoad)
  {
	if(/\( +(\d+) % \)/)
    {
	    $maxbuffer = $maxbuffer<$1 ? $1:$maxbuffer;
	}
  }

  my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
  my $time = $hour*3600 + $min*60 + $sec;
  my $day = $time>=$morning && $time<=$evening ? 1:0;
  $run = ($day && $maxbuffer>=$dbuf) || (!$day==0 && $maxbuffer>=$nbuf)? 1:0;
  my $outstr = "Сейчас ".($day?"день":"ночь").", загруженность буфера ".$maxbuffer."% Пороговое значение ".($day?$dbuf:$nbuf);
  infolog($outstr);
  $outstr = "Для модуля $cmodule выгрузку производить".($run?" уже пора.":" еще рано.");
  infolog($outstr);
  infolog("---------------------------------------------------------");
  infolog("                 indoad_check END");
  infolog("---------------------------------------------------------");
  return $run;
}

# Выгрузка
#
#
sub svdoad
{
  my $cmodule = shift;
  my $command_success = 0;
  infolog("---------------------------------------------------------");
  infolog("                 svdoad BEGIN");
  infolog("---------------------------------------------------------");
  infolog("Начинаем заморозку буфера");
  # Тут нужно повторять команду пока не будет получен правильный ответ
  my ( $iteration, $alltime, $to )  = ( 1, 0, 20 );

  while()
  {
	writechunk("svdoad;");
	$_ = readport($to_atscommand,10,"C$cmodule<",1);
	# Если получили неожиданный ответ, то..
	last if(/svdoad:command entered/);
	errlog("Неожиданный ответ, ожидалось 'svdoad:command entered'");
	sendsms("$station: команда svdoad не принимается более 30 мин") if($alltime > 1800);
	sleep $to;
	checkstop();
	sleep $to;
	checkstop();
	sleep $to;
	$alltime += $to*3;
	# TODO Спросить как поступать здесь.
  }

  ( $alltime, $to )  = ( 0, 20 );

  # Подаем звуковую команду оператору АТС
  $response = `$ALARMDIR/alert.sh $ALARMDIR/on.wav`;
  # Подаем команду redoad:LAMA,N00; пока не получим ответ Command entered
  # С промежутком между командами 1 мин, через каждые 30 мин посылаем звуковую команду и смс
  while()
  {
	writechunk("redoad:LAMA,N00;");
	$_ = readport($to_atscommand,5,"C$cmodule<",1);
	if(/command .* forwarded/)
	{
	  infolog("Команда выполнена успешно!");
	  $command_success = 1;
	  last;
	}

	infolog("Буфер еще не подготовлен") if(/file copies not existent/);
	$response = `$ALARMDIR/alert.sh $ALARMDIR/on.wav` if(/tape unit OFF-LINE/);
	errlog("Ошибка при выгрузке на ленту") if(!/file copies not existent/ && !/tape unit offline/);

	sleep $to;
	checkstop();
	sleep $to;
	checkstop();
	sleep $to;
	$alltime += $to*3;
	if( $alltime > 3400 )
	{
	  $response = `$ALARMDIR/alert.sh $ALARMDIR/on.wav`;
	  sendsms("$station: Буфер подготавливается более 60 мин");
	}
  }
    
  # Сохраняем файл в другую папку
  ( $alltime, $to )  = ( 0, 20 );
  while()
  {
	writechunk("shell:;");
	$_ = readport($to_atscommand,5,"#",1);
	last if(/#/);
	errlog("Ошибка: нет ответа от шелл");
	# Тут надо повторять команду до успешного ответа, если такого нет, то смс отправить
    sleep $to;
    checkstop();
    sleep $to;
    checkstop();
    sleep $to;
    $alltime += $to*3;
    sendsms("$station: не могу зайти в шелл более 30 мин") if($alltime > 1800);
  }
    
  my @time = localtime(time);
  my $year = 1900 + $time[5];
  my $month = 1+ $time[4];
  $month = $month<10?"0".$month:$month;
  my $day = $time[3]<10?"0".$time[3]:$time[3];
  my $hour = $time[2]<10?"0".$time[2]:$time[2];
  my $min = $time[1]<10?"0".$time[1]:$time[1];
  my $sec = $time[0]<10?"0".$time[0]:$time[0];
  $kfilename = $year.$month.$day."_".$hour.$min.$sec.".".$cmodule.".dis";
  ( $alltime, $to )  = ( 0, 20 );
  while()
  {
	writechunk("cp /tmp/doc/disdoc0_f $kfilepath$kfilename\n");
	$_ = readport($to_atscommand,5,"#",1);
	last if(m:cp /tmp/doc/disdoc0_f $kfilepath$kfilename:);
	errlog("Ошибка: операция копирования не завершилась");
	sleep $to;
	checkstop();
	sleep $to;
	checkstop();
	sleep $to;
	$alltime += $to*3;
	sendsms("$station: не могу скопировать файл более 30 мин") if($alltime > 1800);
  }
  # Вводим символ конца файла, для выхода из шелла.
  ( $alltime, $to )  = ( 0, 20 );
  while()
  {
	writechunk(chr(04));
	$_ = readport($to_login,5,"C$cmodule<",1);
	last if(/C$cmodule</);
	errlog("Неожиданный ответ, ожидалось C$cmodule<");
	sleep $to;
	checkstop();
	sleep $to;
	checkstop();
	sleep $to;
	$alltime += $to*3;
	sendsms("$station: не могу выйти из шелл более 30 мин") if($alltime > 1800);
  }
  # Очистка буфера
  infolog("Начинаем очистку буфера.");
  ( $iteration, $alltime, $to )  = ( 1, 0, 20 );
  while()
  {
    infolog( "Попытка $iteration." );
    writechunk( "azdoad;" );
	$_ = readport( $to_atscommand, 5, "C$cmodule<", 1 );
	last if(/command entered/);

	if(!/file  unloading  not  performed/)
	{
		errlog("Неожиданный ответ, ожидалось 'command entered' или 'file  unloading  not  performed'");
	}
	
	sleep $to;
	checkstop();
	sleep $to;
	checkstop();
	sleep $to;
	$alltime += $to*3;
	sendsms("$station: команда azdoad подается более 30 мин") if($alltime > 300);
	$iteration++;
  }
  # Подаем звуковую команду оператору АТС
  $response = `$ALARMDIR/alert.sh $ALARMDIR/off.wav`;
  infolog("---------------------------------------------------------");
  infolog("                 svdoad END");
  infolog("---------------------------------------------------------");
}


# Ручной режим общения с com-портом
#
sub handmode_after_open
{
  infolog("!!!Ручной режим включен!!!");
  print $handmode_run;
  my $begin = "";
  my $str_out = "";
  while($begin ne "q")
  {
	print "write out string:\n";
	chomp($str_out = <STDIN>);
	writechunk($str_out);
	readchunk();
	readchunk();
	print "Continue?('q'-exit)\n";
	chomp($begin = <STDIN>);
  }
  $port->close || die "failed to close";
  undef $port;
  print "Port closed\n";
  print "By!\n";
  exit 0;
}

sub writechunk
{
    my $str=shift;
    my $count = $port->write($str);
    infolog( "Пишем '$count' символов" );
    $str=~s/([^\040-\176])/sprintf("{0x%02X}",ord($1))/ge;
    infolog( "Отправлено ->$str<-" );
}

sub readchunk
{
  # read a chunk of data
  sleep 1;
  my ($count,$str)=$port->read(1);
  my $got;
  my $cnt=$count;
  while ($count>0) 
  {
	($count,$got)=$port->read(1);
	$str.=$got;
	$cnt+=$count;
  }
  print "Читаем $cnt символов\n";
  $str=~s/([^\040-\176])/sprintf("{0x%02X}",ord($1))/ge;
  print "Прочитано ->$str<-\n";
}

# Читаем данные из порта.
# Если $stopch ""(пусто), то читается полное число итераций.
sub readport
{
  my ( $timeout, $iteration, $stopch, $sleep ) = @_; #timeout, iteration count, stop character, sleep
  my ( $count, $str, $got, $cnt, $str_out ) = (0,"","",0,"");
  $iteration = 2 if( !defined( $iteration ) );
  $port->read_const_time($timeout);
  infolog("Читаем данные из порта: таймаут=$timeout, количество попыток=$iteration, стоп-символы='$stopch', таймаут между попытками=$sleep");
  while( $iteration && ( !$stopch || !( $str=~/$stopch/) ) )
  {
	checkstop();
	infolog( "     Осталось попыток: $iteration" );
	( $count, $str ) = $port->read(1);
	$cnt = $count;
	while( $count > 0 )
	{
	    ( $count, $got )=$port->read(1);
	    $str.=$got;
	    $cnt+=$count;
	}
	$str_out.=$str;
	$iteration--;
	#my $printstr = $str;
	#$printstr = ~s/([^\040-\176])/sprintf("{0x%02X}",ord($1))/ge;
	#infolog("     Прочитано: '$printstr'");
	infolog("     Прочитано: '$str'");
	infolog("     Таймаут sleep $sleep");
	sleep $sleep;
  }
  infolog("Ответ: '$str_out'");
  return $str_out;
}


#
# Парсим основной конфиг.
#
sub parse_cfg
{
  my $file = shift;
  infolog("Обрабатываем файл '$file'");
  if(!open(CFGFILE, "$file") )
  {
	errlog("Ошибка при открытии $file. $!\n");
	return 0;
  }

  my @contents = <CFGFILE>;
  close(CFGFILE);

  my $part = "0";
  foreach( @contents )
  {
	next if(m:\S*//:);
	if(/utstation +(.*) +\{?/)
	{
      $station=$1;
      $part="utstation";
	}
	$part="file" if(/file +\{?/);
	$part="bserver" if(/bserver +\{?/);

	if($part eq "utstation")
	{
	  $part="0" if(/\};/);
	  $device = $1 if(/device="(.*)";/);
	  $module = $1 if(/module=(\d);/);
	  if(/exchanges=(\d*)-(\d*);/)
	  {
		$module_min = $1;
		$module_max = $2;
	  }
	  push @schedule, $1 if(/schedule="(.*)";/);
	  $speed = $1 if(/speed=(.*);/);
	  if(/station=(.*);/)
	  {
		errlog("Error $station<>$1") if($station ne $1);
	  }
	  if(/morning=(\d{2}):(\d{2}):(\d{2}):(\d+);/)
	  {
		$morning = $1*3600 + $2*60 + $3;
		$dbuf = $4;
	  }
	  if(/evening=(\d{2}):(\d{2}):(\d{2}):(\d+);/)
	  {
		$evening = $1*3600 + $2*60 + $3;
		$nbuf = $4;
	  }
	}
	if($part eq "file")
	{
	  $part="0" if(/\};/);
	  $fname = $1 if(/name="(.*)";/);
	  $fperm = $1 if(/perm=(\d{4});/);
	  $frotate = $1 if(/rotate=(daily|weekly|monthly);/);
	  $fcompression = $1 if(/compression=(gzip|tar);/);
	  $fcompressionlevel = $1 if(/compression_level=(\d+);/);
	  $ftext = $1 if(/text="(.*)";/);
	  $faregexp = $1 if(/aregexp="(.*)";/);
	  $fbregexp = $1 if(/bregexp="(.*)";/);
	}
	if($part eq "bserver")
	{
      $part="0" if(/\};/);
      $bip = $1 if(/ip=(.*);/);
      $bport = $1 if(/port=(\d+);/);
      $bspool = $1 if(/spool="(.*)";/);
      $bbad = $1 if(/bad="(.*)";/);
	}
  }
	
  $faregexp=~s/;/\\;/g  if(defined($faregexp));
  $fbregexp=~s/;/\\;/g  if(defined($fbregexp));

  if( $station eq "" || $module_min eq "" || $module_max eq "" || $device eq "" || $speed eq "" || $morning eq "" || $dbuf eq "" || $evening eq "" || $nbuf eq "")
  {
	errlog("Некоректный конфигурационный файл! Считанные параметры: station=$station; exchanges=$module_min-$module_max; device=$device; speed=$speed; morning=$morning; dbuf=$dbuf; evening=$evening; nbuf=$nbuf; schedule=@schedule");
	return 0;
  }
  else
  {
	infolog("  Успешно считаны параметры: station=$station; exchanges=$module_min-$module_max; device=$device; speed=$speed; morning=$morning; dbuf=$dbuf; evening=$evening; nbuf=$nbuf; schedule=@schedule");
  }
  if( $fname eq "" || $fperm eq "" || $frotate eq "" || $fcompression eq "" || $fcompressionlevel eq "" || $ftext eq "" )
  {
	errlog("Некоректный конфигурационный файл! Считанные параметры: name=$fname; perm=$fperm; rotate=$frotate; compression=$fcompression; compressionlevel=$fcompressionlevel; text=$ftext;");
	return 0;
  }
  else
  {
	infolog("  Успешно считаны параметры: name=$fname; perm=$fperm; rotate=$frotate; compression=$fcompression; compressionlevel=$fcompressionlevel;");
  }
  if( $bip eq "" || $bport eq "" || $bspool eq "" || $bbad eq "" )
  {
	errlog("Некоректный конфигурационный файл! Считанные параметры: ip=$bip; port=$bport; spool=$bspool; bad=$bbad;");
	return 0;
  }
  else
  {
	infolog("  Успешно считаны параметры:  ip=$bip; port=$bport; spool=$bspool; bad=$bbad;");
	infolog("Файл '$file' успешно обработан");
	return 1;
  }
}

#
# Парсим конфиг для логирования.
#
sub parse_logcfg
{
  my $file = shift;
  open(CFGFILE, "$file") || die "Ошибка при открытии $file. $!\n";
  my @contents = <CFGFILE>;
  close(CFGFILE);
  
  my $part = "0";
  foreach( @contents )
  {
	next if(m:\S*//:);
	$part="log" if(/file m200d_log +\{?/);
	if($part eq "log")
	{
      $part="0" if(/\};/);
      $logdir = $1 if(/file=(.*);/);
      $perm = $1 if(/perm=(\d{4});/);
      $rotate = $1 if(/rotate=(daily|weekly|monthly);/);
      $compression = $1 if(/compression=(gzip|tar);/);
      $compressionlevel = $1 if(/compressionlevel=(\d+);/);
	}
  }

  if($logdir eq "" || $perm eq "" || $rotate eq "" || $compression eq "" || $compressionlevel eq "")
  {
	errlog( "Ошибка! НЕ удалось загрузить конфиг для логирования '$file'! logdir=$logdir perm=$perm rotate=$rotate compression=$compression compressionlevel=$compressionlevel");
	return 0;
  }
  else
  {
	infolog( "****************************************************" );
	infolog( "************ Script colit.pl started ***************" );
	infolog( "****************************************************" );
	infolog( "Файл '$file' успешно обработан, начинаем логирование" );
	infolog( "Успешно считаны параметры. logdir=$logdir perm=$perm rotate=$rotate compression=$compression compressionlevel=$compressionlevel" );
	return 1;
  }
}

#
# Пишем в лог.
#
sub logging
{
  #вопрос что делать если запись в файл неожиданно становится невозможной?
  #вариант отправить смс, и если идет выгрузка, до её окончания продолжать писать в /dev/null
  my $type = shift;
  my $message = shift;
  my $t = localtime(time);
  my $checktime = 0;

  # Длина поля TYPE должна быть ровно 5 символов
  while(length($type)<5)
  {
	$type=" ".$type;
  }

  $type = substr($type,0,5) if( length($type)>5 );
    
  if(-w "$logdir/$logfile")
  {
	# тут нужно смс отправлять и начинать писать в /dev/null
	if( not open(LOGFILE, ">>$logdir/$logfile") )
	{
	  sendsms("Не могу открыть лог, скрипт остановлен");
	  die "Ошибка при открытии $logdir/$logfile. $!\n";
	}
	print LOGFILE "$t $type $app $message\n";
	close(LOGFILE);
  }
  else
  {
	if( not open(LOGFILE, ">$logdir/$logfile") )
	{
	  sendsms("Не могу открыть лог, скрипт остановлен");
	  die "Ошибка при открытии $logdir/$logfile. $!\n";
	}
	print LOGFILE "$t $type $app $message\n";
	close(LOGFILE);
	$response = `chmod $perm $logdir/$logfile` if( $perm );
  }
}


#
# Пишем в лог ошибку.
#
sub errlog
{
    my $message = shift;
    logging("ERROR", $message);
}
#
# Пишем в лог информационное сообщение.
#
sub infolog
{
    my $message = shift;
    logging("INFO", $message);
}

#
# Заблокировать / разблокировать доступ к выгрузке.
#
sub stopload
{
    my $str = shift;
    my $t = localtime(time);
    if(!open(STOPFILE, ">$DIR/stop.lock"))
    {
	errlog("Ошибка при открытии ".$DIR."/stop.lock. $!");
	return 0;
    }
    if($str)
    {
	print STOPFILE "$t stop";
	infolog("Останавливаем работу скрипта");
    }
    else
    {
	print STOPFILE "$t free";
	infolog("Продолжаем работу");
    }
    close(STOPFILE);
}

#
# Проверка на остановку скрипта.
#
sub checkstop
{
  infolog("Проверка на остановку скрипта");
  if(!-r "$DIR/stop.lock")
  {
	infolog("Файл недоступен, продолжаем работу");
	return 0;
  }
  open(STOPFILE, "$DIR/stop.lock") || errlog("Ошибка при открытии ".$DIR."/stop.lock. $!");
  my $line = <STOPFILE>;
  close(STOPFILE);
  if($line=~/stop/)
  {
	infolog("Останавливаем скрипт");
	close_port();
	infolog("Закрыли порт, и на выход.");
	exit 0;
  }
  else
  {
	infolog("Продолжаем работу");
	return 0;
  }
}

#
# Проверка: Пора ли начинать выгрузку по расписанию.
#
sub checktask
{
  infolog("Проверка на задание по расписанию");
  if(!-r "$DIR/stop.lock")
  {
	infolog("Файл недоступен, продолжаем работу");
	return 0;
  }
  open(STOPFILE, "$DIR/stop.lock") || errlog("Ошибка при открытии ".$DIR."/stop.lock. $!");
  my $line = <STOPFILE>;
  close(STOPFILE);
  if($line=~/task/)
  {
	infolog("Пора начинать выгрузку по расписанию");
	$app = "TASK";
	return 1;
  }
  else
  {
	infolog("Продолжаем работу");
	return 0;
  }
}



sub sendsms
{
    my $log = shift;
    my $sms = shift;
    $sms=$log if(!defined($sms));
    errlog($log);
    $response = `$ALARMDIR/sendsms.sh $sms`;
}

sub addcrontask
{
	infolog("Добавляем записи в cron. Создаем файл $DIR/$cronfile");
	open(CRONFILE, ">$DIR/$cronfile") || errlog("Ошибка при открытии $DIR/$cronfile. $!\n");
    my @oldcrontab = `crontab -l`;
	if( $#oldcrontab > -1 )
	{
	  foreach(@oldcrontab)
	  {
		print CRONFILE "$_" if(!/stop.lock/ && !/convert.pl/ && !/archive.pl/ && !/colit:/);
	  }
	}
	else
	{
	  print CRONFILE "SHELL=/bin/sh\n\# colit: Task download\n";
    }
	foreach(@schedule)
	{
	  infolog("Добавляем новую задачу: $_ echo \"task\">stop.lock");
	  print CRONFILE "0 $_ echo \"task\">$DIR/stop.lock\n";
	}
	# задание на конвертацию бинарных файлов в текстовые, выполняется каждый час
	infolog("Добавляем новую задачу: 30 * * * * $DIR/convert.pl -i $bspool -o $ftext -a $faregexp -b $fbregexp >> /dev/null 2>&1");
	#infolog("Добавляем новую задачу: 30 * * * * $DIR/convert.pl -i $bspool -o $ftext -a $faregexp -b $fbregexp >> $DIR/convert.out 2>&1");
	print CRONFILE "# colit: Convert files binary to text\n";
	print CRONFILE "30 * * * * $DIR/convert.pl -i $bspool -o $ftext -a $faregexp -b $fbregexp >> /dev/null 2>&1\n";
	# архивация логов, всех файлов с названием $logfile
	my $task;
    $task = "0 0 * * *" if($rotate eq "daily"); # каждый день в 00:00
	$task = "0 0 * * 0" if($rotate eq "weekly"); # каждое воскресение в 00:00
	$task = "0 0 1 * *" if($rotate eq "monthly"); # каждый месяц 1 числа в 00:00
	infolog("Добавляем новую задачу: $task $DIR/archive.pl $compression $compressionlevel $logdir $logfile n  >> /dev/null 2>&1");
	print CRONFILE "# colit: Compressing logs\n";
	print CRONFILE "$task $DIR/archive.pl $compression $compressionlevel $logdir $logfile n  >> /dev/null 2>&1\n";
	# архивация бинарных файлов, всех файлов с расширением dis
    $task = "0 0 * * *" if($frotate eq "daily"); # каждый день в 00:00
	$task = "0 0 * * 0" if($frotate eq "weekly"); # каждое воскресение в 00:00
	$task = "0 0 1 * *" if($frotate eq "monthly"); # каждый месяц 1 числа в 00:00
	infolog("Добавляем новую задачу: task $DIR/archive.pl $fcompression $fcompressionlevel $fname .dis o >> /dev/null 2>&1");
	print CRONFILE "# colit: Compressing data files\n";
	print CRONFILE "$task $DIR/archive.pl $fcompression $fcompressionlevel $bspool .dis o >> /dev/null 2>&1\n";
	close(CRONFILE);
	infolog("Создан файл $DIR/$cronfile");
	$response = `crontab $DIR/$cronfile`;
	infolog("Задания добавлены в cron: $response");
 
}

sub delcrontask
{
	infolog("Удаляем записи из cron.");
    my @oldcrontab = `crontab -l`;
	if( $#oldcrontab > -1 )
	{
	  infolog("Создаем файл $DIR/$cronfile.");
	  open(CRONFILE, ">$DIR/$cronfile") || errlog("Ошибка при открытии $DIR/$cronfile. $!\n");
	  foreach(@oldcrontab)
	  {
		print CRONFILE "$_" if(!/stop.lock/ && !/convert.pl/ && !/archive.pl/ && !/colit:/);
	  }
	  close(CRONFILE);
	  infolog("Создан файл $DIR/$cronfile");
	  $response = `crontab $DIR/$cronfile`;
	  infolog("Задания удалены из cron");
	  $response = `rm $DIR/$cronfile`;
	}
}

1;
}
