#! /usr/bin/perl

use Device::SerialPort;
use Collector;
use strict;

my $response = ""; #переменная для получения результата системных команд

my $help = "Управление: colit.pl [command]
	-conf			проверить конфигурационные файлы
	-login [module]		залогиниться на указанный модуль, если не указан берется из конфига
	-indoad	[module]	проверка на выгрузку с указанного модуля, если не указан берется из конфига
	-redoad [module]	выгрузить с указанного модуля, если не указан берется из конфига
	-start		запустить плановый режим 
	-download  [filename] [filepath] [download-directory]
			загрузка файла по протоколу Kermit,
			filename - что закачать, обязательный параметр.
			filepath - откуда закачать, если не указан берется из конфига,
			download-directory - куда закачать, если не указан берется из конфига,
	-handmode		ручной режим
	-stop			остановить скрипт
	-addtask		добавить задания в cron
	-deletetask		удалить задания из cron
	--help			показать эту справку и выйти\n";

if($ARGV[0]=~/^-conf$/)
{
	print "Checking configurations files\n";
	exit 0 if( not conf() );
	print "End command -conf\n";
}
elsif($ARGV[0]=~/^-login$/)
{
	login( $ARGV[1] );
}
elsif($ARGV[0]=~/^-indoad$/)
{
	indoad( $ARGV[1] );
}
elsif($ARGV[0]=~/^-redoad$/)
{
	redoad( $ARGV[1] );
}
elsif($ARGV[0]=~/^-start$/)
{
	start();
}
elsif($ARGV[0]=~/^-download$/)
{
  if(!defined($ARGV[1]))
  {
	print "colit: не хватает аргументов для команды «-download»\nПопробуйте `colit.pl --help' для получения более подробного описания.\n";
  }
  download( $ARGV[1], $ARGV[2], $ARGV[3] );
}
elsif($ARGV[0]=~/^-handmode$/)
{
  handmode();
}
elsif($ARGV[0]=~/^-stop$/)
{
  $response = `echo "stop" > $Collector::DIR/stop.lock`;
}
elsif($ARGV[0]=~/^-addtask$/)
{
  conf();
  addcrontask();
}
elsif($ARGV[0]=~/^-deletetask$/)
{
  delcrontask();
}
elsif($ARGV[0]=~/^--help$/)
{
	print "$help\n";
}
else
{
	print "colit: неверный аргумент «$ARGV[0]»\nПопробуйте `colit.pl --help' для получения более подробного описания.\n";
}

