#! /usr/bin/perl
use strict;
use File::Path;
my $VERSION = '1.0';
my $DIR = "/usr/local/bin/colit";
my ($yyyy, $mm, $dd);
my $OUT = "/usr/local/bin/colit/out";
my $IN = $DIR."/source";
my ($aregexp, $bregexp);
my @AR;
my @BR;
my $help = "usage: convert.pl [key] [param]
 -i input directory, default $IN
 -o output directory, default $OUT
 -a regexp for A-phone, default none
 -b regexp for B-phone, default none";
my $var="1";
foreach my $arg (@ARGV)
{
  if( $var eq "-i")
  {
	$IN = $arg;
	$var = "1";
  }
  elsif($var eq "-o")
  {
	$OUT = $arg;
	$var = "1";
  }
  elsif($var eq "-a")
  {
	@AR = split(/;/, $arg);
	$var = "1";
  }
  elsif($var eq "-b")
  {
	@BR = split(/;/, $arg);
	$var = "1";
  }
  elsif($arg =~ /-i|-o|-a|-b/)
  {
	$var = $arg;
  }
}

if($ARGV[0] eq "--help")
{
  print "$help\n";
  exit(0);
}

print "@AR\n";
print "@BR\n";

opendir (DIR,"$IN");
foreach my $cur_file (readdir(DIR))
{
  if( $cur_file =~ /^(\d{4})(\d{2})(\d{2})_\d{6}.\d.dis$/ )  
  {
	($yyyy, $mm, $dd) = ($1, $2, $3);
	
	mkpath("$OUT/$yyyy/$mm/" );

	my $out_file = $cur_file;
	$out_file =~ s/dis/txt/;

	open FILE_OUT, ">$OUT/$yyyy/$mm/$out_file" || die "Can't open $out_file on write!\n";

	parse("$cur_file");
	close FILE_OUT;	
  }
}
closedir (DIR);

#
# Парсим сырой файл.
#
sub parse
{
  my $file = shift;
  open(FILE,"<:bytes:raw", "$IN/$file") || die "Ошибка при открытии $file. $!\n";
  
  my $block;
  my @c;
  my $format_str = 'A[18]';
  my $format_str2 = 'scLLsccssssssssc5';
  read(FILE, $block, 18);
  @c = unpack($format_str, $block);
  #print "@c\n";
  while( read(FILE, $block, 36))
  {
	@c = unpack($format_str2, $block);
#	print "@c\n";

	$c[5] = $c[5]<10?"0".$c[5]:$c[5];
	$c[6] = $c[6]<10?"0".$c[6]:$c[6];
    $c[9] = $c[9]<10?"0".$c[9]:$c[9];
	$c[8] = $c[8]<10?"0".$c[8]:$c[8];
	$c[7] = $c[7]<10?"0".$c[7]:$c[7];
    $c[12] = $c[12]<10?"0".$c[12]:$c[12];
	$c[11] = $c[11]<10?"0".$c[11]:$c[11];
	$c[10] = $c[10]<10?"0".$c[10]:$c[10];
	if(length($c[3])<$c[18])
	{
	  while(length($c[4])+length($c[3])<$c[18])
	  {
		$c[3] = $c[3]."0";
	  }
	  $c[3] = $c[3].$c[4];
	}
	foreach(@AR)
	{
	  if(m:(.*)/(.*):)
	  {
		my $re1 = qr/$1/;
		my $re2 = $2;
		$c[2] =~s/$re1/$re2/;
	  }
	  
	}
	foreach(@BR)
	{
	  if(m:(.*)/(.*):)
	  {
		my $re1 = qr/$1/;
		my $re2 = $2;
		$c[3] =~s/$re1/$re2/;
	  }
	}
	print FILE_OUT "$c[1] $c[2] $c[3] $yyyy-$c[6]-$c[5] $c[9]:$c[8]:$c[7] $c[12]:$c[11]:$c[10] $c[13] $c[15] $c[16] $c[17] $c[18]\n";
  }
  close(FILE);
}

